#!/bin/bash


# This script dumps the database, deletes the database, loads the database, dumps it again...
# ...and then compares the two dumps to see if we have full fidelity between them.
#
# Did you read that correctly?  Yes, it will DELETE your database.  So don't run this.

exit 0		# In fact, here's an exit statement you must delete before you can even run it.

ps ax | grep citserver | grep -v grep >/dev/null 2>/dev/null && {
	echo dont do this while the server is running
	exit 1
}

./ctdldump -y >dump.dat
first=$(md5sum dump.dat | awk ' { print $1 } ' )
rm -fv data/*
./ctdlload -y <dump.dat
./ctdldump -y >dump.dat
second=$(md5sum dump.dat | awk ' { print $1 } ' )

echo
echo
echo MD5 of initial dump: ${first}
echo MD5 of sequent dump: ${second}
echo
if [ ${first} == ${second} ] ; then
	echo Congratulations, you have full fidelity between two dumps.
else
	echo Epic fail, you do NOT have full fidelity between two dumps.
fi
