// Copyright (c) 1987-2023 by the citadel.org team
// This program is open source software.  Use, duplication, or disclosure
// is subject to the terms of the GNU General Public License, version 3.

// These functions comprise an interface between Citadel Server and a database backend.

#ifndef DATABASE_H
#define DATABASE_H

extern void		cdb_init_backends(void);
extern void		cdb_chmod_data(void);

extern void		(*cdb_open_databases)(void);
extern void		(*cdb_close_databases)(void);
extern int		(*cdb_store)(int, const void *, int, void *, int);
extern int		(*cdb_delete)(int, void *, int);
extern struct cdbkeyval	(*cdb_next_item)(int);
extern void		(*cdb_close_cursor)(int);
extern void		(*cdb_begin_transaction)(void);
extern void		(*cdb_end_transaction)(void);
extern void		(*cdb_check_handles)(void);
extern void		(*cdb_trunc)(int);
extern void		(*check_handles)(void *);
extern struct cdbdata 	(*cdb_fetch)(int, const void *, int);
extern void		(*cdb_checkpoint)(void);
extern void		(*cdb_compact)(void);
extern void		(*cdb_rewind)(int);
extern void		(*cdb_tick)(void);

#endif
