// checkpointing module for the database
//
// Copyright (c) 1987-2024 by the citadel.org team
//
// This program is open source software.  Use, duplication, or disclosure
// is subject to the terms of the GNU General Public License, version 3.
 
#include "../../sysdep.h"
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>

#include <libcitadel.h>

#include "../../citadel_defs.h"
#include "../../server.h"
#include "../../citserver.h"
#include "../../msgbase.h"
#include "../../sysdep_decls.h"
#include "../../config.h"
#include "../../threads.h"
#include "../../ctdl_module.h"
#include "../../context.h"

// Initialization function, called from modules_init.c
char *ctdl_module_init_checkpoint(void) {
	if (threading) {
		CtdlRegisterSessionHook(cdb_checkpoint, EVT_TIMER, PRIO_CLEANUP + 10);
	}
	// return our module name for the log
	return "checkpoint";
}
