// This module handles the view for "calendar" rooms.
//
// Copyright (c) 2016-2023 by the citadel.org team
//
// This program is open source software.  Use, duplication, or
// disclosure is subject to the GNU General Public License v3.


// RENDERER FOR THIS VIEW
function view_render_calendar() {
	fetch(
		"/ctdl/r/" + escapeHTMLURI(current_room) + "/calendar::"
	)
	.then(response => {
		if (response.ok) {
			return(response.json());
		}
		else {
			throw new Error(`${response.status} ${response.statusText}`);
		}
	})
	.then(j => {
		document.getElementById("ctdl-main").innerHTML = JSON.stringify(j);
	})
	.catch(error => {
		console.log(error);
		document.getElementById("ctdl-main").innerHTML = `<div class="ctdl-fatal-error">${error}</div>`;
	});
}
